function makeModel()
  grid_n1 = 200
  grid_n2 = 50
  grid_n = grid_n1 + grid_n2
  cbar = 0.
  lb = 0.
  ub = 3000.
  #ub = 10.
  grid = loggrid(lb, ub, grid_n)
  #grid = [collect(linspace(lb, 10., grid_n1)) ; collect(linspace(10.1, ub, grid_n2)) ]

  alpha = 0.376
  dep = 0.059
  PT = ProductionTechnology(alpha, dep)
  #beta = 0.924
  beta = 0.96
  omega = 0.5 # Transfers to retired
  HB = HouseholdBehavior(beta, omega)

  #sigmac = 1.5
  sigmac = 1.458
  sigmal = 1.016
  #sigmal = 1.2
  phi = 1.138
  #hoursmax = 3.2
  hoursmax = 1.
  #dm = [0.3]
  dm = [0.856]
  df = [2*phi]
  #hbar = 0.2
  hbar = 0.
  UF = CRRA_Family(sigmac, dm, df, sigmal, hbar, hoursmax)
  #UF = CRRA(sigmac, df, sigmal, hbar, hoursmax)

  Gee=1/100* (
    [96.24 1.14 0.39 0.006 ;
     3.07 94.33 0.37 0;
     1.5 0.43 95.82 0.02;
     10.66 0.49 6.11 80.51]; )
  Gee=Gee-diagm(sum(Gee, 2)[:] - 0.9778) #Fix rounding errors from the paper
  Pi_sp_EE = Gee ./ sum(Gee, 2)
  Pi_sp_ER = eye(4)
  Pi_sp_RR = eye(4)
  Gre = zeros(4,4)

  statE=[61.11;22.35;16.5;0.0389]/100;
  statE=statE/sum(statE);
  phi1=0.969;
  phi2=0.525;
  Gre[1:1,1]=[1 phi1 phi1^2 phi1^3]*statE;
  Gre[1:1, 2]=[0 1-phi1 (1-phi1)*phi1 (1-phi1)*phi1^2]*statE;
  Gre[1:1, 3]=(1-phi1)*[0 0 1 phi1]*statE;
  Gre[1:1, 4]=(1-phi1)*[0 0 0 1]*statE;
  Gre[2:2, 1]=(1-phi1)*[1 0 0 0]*statE;
  Gre[2:2, 2]=[phi1 1 phi1 phi1^2]*statE;
  Gre[2:2, 3]=(1-phi1)*[0 0 1 phi1]*statE;
  Gre[2:2, 4]=(1-phi1)*[0 0 0 1]*statE;
  Gre[3:3, 1]=(1-phi1)*[1 0 0 0]*statE;
  Gre[3:3, 2]=(1-phi1)*[phi1 1 0 0]*statE;
  Gre[3:3, 3]=[phi1^2 phi1 1 phi1]*statE;
  Gre[3:3, 4]=(1-phi1)*[0 0 0 1]*statE;
  Gre[4:4, 1]=(1-phi1)*[1 0 0 0]*statE;
  Gre[4:4, 2]=(1-phi1)*[phi1 1 0 0]*statE;
  Gre[4:4, 3]=(1-phi1)*[phi1^2 phi1 1 0]*statE;
  Gre[4:4, 4]=[phi1^3 phi1^2 phi1 1]*statE;

  tempGre=zeros(4, 4);
  for i=1:4
    tempGre[i,1]=Gre[i,1]+phi2*Gre[i,2]+phi2^2*Gre[i,3]+phi2^3*Gre[i,4];
    tempGre[i,2]=(1-phi2)*(Gre[i,2]+phi2*Gre[i,3]+phi2^2*Gre[i,4]);
    tempGre[i,3]=(1-phi2)*(Gre[i,3]+phi2*Gre[i,4]);
    tempGre[i,4]=(1-phi2)*Gre[i,4];
  end
  Pi_sp_RE = tempGre

  Pi_s = zeros(4,4, 2, 2, 1)
  Pi_s[:, :, 1, 1, 1] = Pi_sp_EE
  Pi_s[:, :, 1, 2, 1] = Pi_sp_ER
  Pi_s[:, :, 2, 1, 1] = Pi_sp_RE
  Pi_s[:, :, 2, 2, 1] = Pi_sp_RR

  #Pi_s[:, :, :, :, 2] = Pi_s[:, :, :, :, 1]


  #rho_re=0.0222;
  rho_re = 0.
  #rho_rr=1-0.066;
  rho_rr = 1.
  Pi_r = [1 - rho_re rho_re ;
          1 - rho_rr rho_rr]


  lambda_e_m = 1. #0.92
  lambda_n_m = 0. #0.25
  lambda_e_f = 1. #0.92
  lambda_n_f = 0. #0.25
  Pi_emp_m = zeros(2, 2)
  Pi_emp_m[:, 1] = [lambda_e_m ; 1 - lambda_e_m]
  Pi_emp_m[:, 2] = [1 - lambda_n_m; lambda_n_m]
  Pi_emp_f = zeros(2, 2)
  Pi_emp_f[:, 1] = [lambda_e_f ; 1 - lambda_e_f]
  Pi_emp_f[:, 2] = [1 - lambda_n_f; lambda_n_f]


  #s_vals = [1; 3.15; 9.78; 1061]
  s_vals = ones(4)
  mu_female = 0.
  #mu_female = 1.
  #cbar = 0.
  IP = IncomeProcess(Pi_s, Pi_r, Pi_emp_m, Pi_emp_f, s_vals, mu_female, cbar)


  a0=.258;
  a1=.768;
  a2=.491;
  a3=.144;
  zlower=14.101;
  tauE=.16;

  estatetaxes = EstateTaxes(zlower, tauE)
  incometaxes = IncomeTaxes(a0, a1, a2, a3)

  #as = AggState(0.06, 1.2481)
  as = AggState(0.03234564208984373, 1.2321462252537372)
  budget_hours_minconsump_guess_NW = ones(grid_n, length(s_vals), 2, 2, 2, length(dm)) * hbar
  budget_hours_minconsump_guess_WW = ones(grid_n, length(s_vals), 2, 2, 2, length(dm)) * hbar
  budget_hours_guess_NW = ones(grid_n, length(s_vals), 2, 2, 2, length(dm))
  budget_hours_guess_WW = ones(grid_n, length(s_vals), 2, 2, 2, length(dm))
  VFsize = size(budget_hours_minconsump_guess_NW)
  estate_send_nx = ones(Int, grid_n)
  estate_send_nx = collect(1:grid_n)
  brentguess = zeros(grid_n, length(s_vals), 2, 2, 2, length(dm), 4) # 4 is the number of work status pairs
  IS_array = Array(IdioState, grid_n, length(s_vals), 2, 2, 2, length(dm))
  Intra_vals = Inf*ones(Float64, grid_n, grid_n, length(s_vals), 2, 2, 2, length(dm), 4)
  Intra_vals_check = zeros(Bool, size(Intra_vals))
  storage = Storage(budget_hours_minconsump_guess_NW, budget_hours_minconsump_guess_WW,
                    budget_hours_guess_NW, budget_hours_guess_WW,
                    brentguess, estate_send_nx, VFsize, IS_array, Intra_vals, Intra_vals_check)
  model = Model(UF, IP, HB, PT, incometaxes, estatetaxes, as, grid, storage)
  n_a, n_s, n_ret, n_emp_m, n_emp_f, n_d = VFsize
  for s_nx in 1:n_s, ret_nx in 1:n_ret, emp_m_nx in 1:n_emp_m, emp_f_nx in 1:n_emp_f, d_nx in 1:n_d
    for a_nx in 1:n_a
      model.storage.IS_array[a_nx, s_nx, ret_nx, emp_m_nx, emp_f_nx, d_nx] = buildState(a_nx, s_nx, ret_nx, emp_m_nx, emp_f_nx, d_nx, model)
    end
  end

  estate_send_nx = locate(Float64[a - estatetax(a, model) for a in grid], grid)
  model.storage.estate_send_nx[:] = estate_send_nx[:]
  return model
end

